osgVolume::Locator Class Reference

`#include <Locator>`

Inheritance diagram for osgVolume::Locator:

## Classes

class | LocatorCallback

## Public Types

typedef std::vector< osg::ref_ptr< LocatorCallback > > | LocatorCallbacks
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Locator ()
| Locator (const osg::Matrixd &transform)
| Locator (const Locator &locator, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgVolume, Locator)
void | setTransform (const osg::Matrixd &transform)
const osg::Matrixd & | getTransform () const
void | setTransformAsExtents (double minX, double minY, double maxX, double maxY, double minZ, double maxZ)
virtual bool | convertLocalToModel (const osg::Vec3d &, osg::Vec3d &) const
virtual bool | convertModelToLocal (const osg::Vec3d &, osg::Vec3d &) const
bool | computeLocalBounds (osg::Vec3d &bottomLeft, osg::Vec3d &topRight) const
bool | computeLocalBounds (Locator &source, osg::Vec3d &bottomLeft, osg::Vec3d &topRight) const
bool | inverted () const
void | applyAppropriateFrontFace (osg::StateSet *ss) const
void | addCallback (LocatorCallback *callback)
template<class T>
void | addCallback (const osg::ref_ptr< T > &callback)
void | removeCallback (LocatorCallback *callback)
LocatorCallbacks & | getLocatorCallbacks ()
const LocatorCallbacks & | getLocatorCallbacks () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static bool | convertLocalCoordBetween (const Locator &source, const osg::Vec3d &sourceNDC, const Locator &destination, osg::Vec3d &destinationNDC)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Member Functions

void | locatorModified ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::Matrixd | _transform
osg::Matrixd | _inverse
LocatorCallbacks | _locatorCallbacks
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Typedef Documentation

## LocatorCallbacks

typedef std::vector< osg::ref_ptr<LocatorCallback> > osgVolume::Locator::LocatorCallbacks

## Constructor & Destructor Documentation

## Locator() [1/3]

osgVolume::Locator::Locator | ( |  | ) |

inline

Referenced by computeLocalBounds(), convertLocalCoordBetween(), Locator(), osgVolume::Locator::LocatorCallback::locatorModified(), and META_Object().

## Locator() [2/3]

osgVolume::Locator::Locator | ( | const osg::Matrixd & | transform | ) |

inline

References setTransform().

## Locator() [3/3]

osgVolume::Locator::Locator | ( | const Locator & | locator,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

Copy constructor using CopyOp to manage deep vs shallow copy.

References _transform, Locator(), osg::Object::Object(), and osg::CopyOp::SHALLOW_COPY.

## Member Function Documentation

## addCallback() [1/2]

template<class T>

void osgVolume::Locator::addCallback | ( | const osg::ref_ptr< T > & | callback | ) |

inline

References addCallback(), and osg::ref_ptr< T >::get().

Referenced by addCallback().

## addCallback() [2/2]

void osgVolume::Locator::addCallback | ( | LocatorCallback * | callback | ) |

## applyAppropriateFrontFace()

void osgVolume::Locator::applyAppropriateFrontFace | ( | osg::StateSet * | ss | ) | const

apply the appropriate FrontFace setting to provided StateSet to ensure that the rendering of hull of the volume is the correct orientation.

## computeLocalBounds() [1/2]

bool osgVolume::Locator::computeLocalBounds | ( | Locator & | source,
|  | osg::Vec3d & | bottomLeft,
|  | osg::Vec3d & | topRight ) const

References Locator().

## computeLocalBounds() [2/2]

bool osgVolume::Locator::computeLocalBounds | ( | osg::Vec3d & | bottomLeft,
|  | osg::Vec3d & | topRight ) const

## convertLocalCoordBetween()

bool osgVolume::Locator::convertLocalCoordBetween | ( | const Locator & | source,
|  | const osg::Vec3d & | sourceNDC,
|  | const Locator & | destination,
|  | osg::Vec3d & | destinationNDC )

inline static

References convertLocalToModel(), convertModelToLocal(), and Locator().

## convertLocalToModel()

virtual bool osgVolume::Locator::convertLocalToModel | ( | const osg::Vec3d & | ,
|  | osg::Vec3d & | ) const

virtual

Referenced by convertLocalCoordBetween().

## convertModelToLocal()

virtual bool osgVolume::Locator::convertModelToLocal | ( | const osg::Vec3d & | ,
|  | osg::Vec3d & | ) const

virtual

Referenced by convertLocalCoordBetween().

## getLocatorCallbacks() [1/2]

LocatorCallbacks & osgVolume::Locator::getLocatorCallbacks | ( |  | ) |

inline

References _locatorCallbacks.

## getLocatorCallbacks() [2/2]

const LocatorCallbacks & osgVolume::Locator::getLocatorCallbacks | ( |  | ) | const

inline

References _locatorCallbacks.

## getTransform()

const osg::Matrixd & osgVolume::Locator::getTransform | ( |  | ) | const

inline

Set the transformation from local coordinates to model coordinates.

References _transform.

## inverted()

bool osgVolume::Locator::inverted | ( |  | ) | const

Return true if the axis of the Locator are inverted requiring the faces of any cubes used from rendering to be flipped to ensure the correct front/back face is used.

## locatorModified()

void osgVolume::Locator::locatorModified | ( |  | ) |

protected

Referenced by setTransform().

## META_Object()

osgVolume::Locator::META_Object | ( | osgVolume | ,
|  | Locator | )

References Locator().

## removeCallback()

void osgVolume::Locator::removeCallback | ( | LocatorCallback * | callback | ) |

## setTransform()

void osgVolume::Locator::setTransform | ( | const osg::Matrixd & | transform | ) |

inline

Set the transformation from local coordinates to model coordinates.

References _inverse, _transform, and locatorModified().

Referenced by Locator().

## setTransformAsExtents()

void osgVolume::Locator::setTransformAsExtents | ( | double | minX,
|  | double | minY,
|  | double | maxX,
|  | double | maxY,
|  | double | minZ,
|  | double | maxZ )

Set the extents of the local coords.

## Member Data Documentation

## _inverse

osg::Matrixd osgVolume::Locator::_inverse

protected

Referenced by setTransform().

## _locatorCallbacks

LocatorCallbacks osgVolume::Locator::_locatorCallbacks

protected

Referenced by getLocatorCallbacks(), and getLocatorCallbacks().

## _transform

osg::Matrixd osgVolume::Locator::_transform

protected

Referenced by getTransform(), Locator(), and setTransform().

The documentation for this class was generated from the following file:

- osgVolume/Locator